var debug = true;
var timer = null;
var apiKey = "";
var monitor;

document.onreadystatechange = function()
{    
    if(document.readyState == "complete")
    {        		
		alert('start');
		monitor = new Monitor();
        System.Gadget.settingsUI = "settings.htm";
        System.Gadget.onSettingsClosed = settingsClosed;
		loadSettings();
        startMonitoring();
    }        
}

function alert(msg)
{
    if (debug)
    {
        System.Debug.outputString(msg);
    }
}

function startMonitoring()
{    
	alert('monitoringkey ' + apiKey);
	if(timer == null)
    {
        timer = setInterval("startMonitoring()", 60000);
    }  
   
   if (apiKey == "")
   {
       return;
   }
   
    if(System.Gadget.visible == true)
    {    
		alert('monitoring');
        monitor.startMonitor();             
    }
}

function setStatus(statusCode)
{
   alert(statusCode);
   if (statusCode == 0)
   {
		statusIcon.src = 'resources/icon_up.png';
		statusText.innerText = 'all systems go';
   }
   else
   {
		statusIcon.src = 'resources/icon_down.png';	
		statusText.innerText = statusCode + ' systems down';
   }
}

function settingsClosed(event)
{
    if(event.closeAction == event.Action.commit)
    {   
        loadSettings();
		startMonitoring();
    }
}

function loadSettings()
{
    var apikey = System.Gadget.Settings.read("apikey");
	if(apikey != "")
    {
        apiKey = apikey;		
    }		
}

function Monitor()
{
    this.xmlHttp =  new XMLHttpRequest();
	this.status = 0;
    this.apiKey = apiKey;
    this.timer = null;    
}

Monitor.prototype.startMonitor = function()
{
	this.status = this.makeRequest();	
}

Monitor.prototype.makeRequest = function()
{
    this.xmlHttp.open("GET", "http://www.montastic.com/feeds/quick_status?key=" + apiKey, false);
    this.xmlHttp.send();   
    var status = eval(this.xmlHttp.responseText);	
	setStatus(status);
	return status;
}